#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

int main(int argc, char** argv) {
	
	if (argc != 3) {
		exit(EXIT_FAILURE);
	}
	
	struct stat fInfo;
	if (stat(argv[1], &fInfo) == -1) {
		exit(EXIT_FAILURE);
	}
	
	mode_t oldMode = fInfo.st_mode;
	
	switch (argv[2][0]){
		
		case 'u':
			if (argv[2][1] == '-') {
				if (argv[2][2] == 'r') {
					oldMode &= ~S_IRUSR;
				}
				else if (argv[2][2] == 'w') {
					oldMode &= ~S_IWUSR;
				}
				else if (argv[2][2] == 'x') {
					oldMode &= ~S_IXUSR;
				}
				else {
					exit(EXIT_FAILURE);
				}
			}
			else if (argv[2][1] == '+') {
				if (argv[2][2] == 'r') {
					oldMode |= S_IRUSR;
				}
				else if (argv[2][2] == 'w') {
					oldMode |= S_IWUSR;
				}
				else if (argv[2][2] == 'x') {
					oldMode |= S_IXUSR;
				}
				else {
					exit(EXIT_FAILURE);
				}
			}
			else {
				exit(EXIT_FAILURE);
			}
			break;
		case 'g':
			if (argv[2][1] == '-') {
				if (argv[2][2] == 'r') {
					oldMode &= ~S_IRGRP;
				}
				else if (argv[2][2] == 'w') {
					oldMode &= ~S_IWGRP;
				}
				else if (argv[2][2] == 'x') {
					oldMode &= ~S_IXGRP;
				}
				else {
					exit(EXIT_FAILURE);
				}
			}
			else if (argv[2][1] == '+') {
				if (argv[2][2] == 'r') {
					oldMode |= S_IRGRP;
				}
				else if (argv[2][2] == 'w') {
					oldMode |= S_IWGRP;
				}
				else if (argv[2][2] == 'x') {
					oldMode |= S_IXGRP;
				}
				else {
					exit(EXIT_FAILURE);
				}
			}
			else {
				exit(EXIT_FAILURE);
			}
			break;
		case 'o':
			if (argv[2][1] == '-') {
				if (argv[2][2] == 'r') {
					oldMode &= ~S_IROTH;
				}
				else if (argv[2][2] == 'w') {
					oldMode &= ~S_IWOTH;
				}
				else if (argv[2][2] == 'x') {
					oldMode &= ~S_IXOTH;
				}
				else {
					exit(EXIT_FAILURE);
				}
			}
			else if (argv[2][1] == '+') {
				if (argv[2][2] == 'r') {
					oldMode |= S_IROTH;
				}
				else if (argv[2][2] == 'w') {
					oldMode |= S_IWOTH;
				}
				else if (argv[2][2] == 'x') {
					oldMode |= S_IXOTH;
				}
				else {
					exit(EXIT_FAILURE);
				}
			}
			else {
				exit(EXIT_FAILURE);
			}
			break;
		default:
			exit(EXIT_FAILURE);
	}
	
	if (chmod(argv[1], oldMode) == -1) {
		exit(EXIT_FAILURE);
	}
		
	exit(EXIT_SUCCESS);
}
