#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

int main(int argc, char** argv) {
	
	if (argc != 4) {
		exit(EXIT_FAILURE);
	}
	
	int fd = open(argv[1], O_RDONLY);
	if (fd == -1){
		exit(EXIT_FAILURE);
	}
	
	int fromPos = strtol(argv[2], NULL, 10);
	int length = strtol(argv[3], NULL, 10);
	
	if (lseek(fd, fromPos, SEEK_SET) == (off_t)-1){
		exit(EXIT_FAILURE);
	}
	
	char* buffer = malloc(length + 2);
	if (buffer == NULL){
		exit(EXIT_FAILURE);
	}	
	
	int readBytes = 0;
	while (length > 0) {
		
		readBytes = read(fd, buffer, length);
		
		if (readBytes == -1) {
			exit(EXIT_FAILURE);
		}
		else if (readBytes == 0) {
			break;
		}
		
		if(write(STDOUT_FILENO, buffer, readBytes) == -1) {
			exit(EXIT_FAILURE);
		}
		
		length -= readBytes;
	}
	
	close(fd);
	free(buffer);
	
	exit(EXIT_SUCCESS);
}
